/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBu(ڑF)v
//!
//! ̧ق͕W(ڑF)菇ɑΉUSB߲0Ǘ܂݂܂(USBd
//! l̑9͂QƂĂ)B
//! ̧ق͔WvǗ̂߂usb_specific_request.çقٰ݂Ăт܂B
//! (ڑF)Ұ(Lqq\)usb_descriptors.çقɊ܂܂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "lib_mcu/usb/usb_drv.h"
#include "lib_mcu/pll/pll_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"

#if ((USB_DEVICE_SN_USE==ENABLE) && (USE_DEVICE_SN_UNIQUE==ENABLE))
#include "lib_mcu/flash/flash_drv.h"
static U8 bin_to_ascii (U8 b);
#endif

//_____ ` _______________________________________________________________

static Bool usb_get_descriptor    (void);
static void usb_set_address       (void);
static Bool usb_set_configuration (void);
static void usb_get_configuration (void);
static Bool usb_get_status        (U8 bmRequestType);
static Bool usb_set_feature       (U8 bmRequestType);
static Bool usb_clear_feature     (U8 bmRequestType);
static Bool usb_get_interface     (void);
static Bool usb_set_interface     (void);

#ifndef USB_REMOTE_WAKEUP_FEATURE
  #error USB_REMOTE_WAKEUP_FEATURE should be defined as ENABLE or DISABLE in conf_usb.h
#endif

#if (USE_DEVICE_SN_UNIQUE==ENABLE)
  U8 f_get_serial_string=FALSE;
#endif

//_____ 錾 _______________________________________________________________

#ifdef __GNUC__								// AVRGCCPGMԂւ̎wx܂B
  PGM_VOID_P pbuffer;
  #define Usb_write_PGM_byte(byte) (Usb_write_byte(pgm_read_byte_near((unsigned int)byte)))
#else
  U8 code *pbuffer;
  #define Usb_write_PGM_byte(byte) (Usb_write_byte(*byte))
#endif

U8 endpoint_status[MAX_EP_NB];
U8 data_to_transfer;
U8 usb_configuration_nb;
U8 remote_wakeup_feature = DISABLE;
U8 device_status = DEVICE_STATUS;

//! @brief ̊֐͊萧߲Ă֑ꂽ\ݒ(SETUP)vǂ݁AK
//! Ȋ֐Ăт܂Busb_read_request֐𔲂鎞ɁAu͎̗vǗ
//! 邽߂̏Ă܂B
//!
void usb_process_request (void)
{
	U8 bmRequestType;
	U8 bmRequest;

	Usb_ack_control_out();
	bmRequestType = Usb_read_byte();
	bmRequest     = Usb_read_byte();

	switch (bmRequest)
	{
		case SETUP_GET_DESCRIPTOR:
			if (USB_SETUP_GET_STAND_DEVICE == bmRequestType)
			{
				if( usb_get_descriptor() )
					return;
			}
			break;

		case SETUP_GET_CONFIGURATION:
			if (USB_SETUP_GET_STAND_DEVICE == bmRequestType)
			{
				usb_get_configuration();
				return;
			}
			break;

		case SETUP_SET_ADDRESS:
			if (USB_SETUP_SET_STAND_DEVICE == bmRequestType)
			{
				usb_set_address();
				return;
			}
			break;

		case SETUP_SET_CONFIGURATION:
			if (USB_SETUP_SET_STAND_DEVICE == bmRequestType)
			{
				if( usb_set_configuration() )
					return;
			}
			break;

		case SETUP_CLEAR_FEATURE:
			if (usb_clear_feature(bmRequestType))
				return;
			break;

		case SETUP_SET_FEATURE:
			if (usb_set_feature(bmRequestType))
				return;
			break;

		case SETUP_GET_STATUS:
			if (usb_get_status(bmRequestType))
				return;
			break;

		case SETUP_GET_INTERFACE:
			if (USB_SETUP_GET_STAND_INTERFACE == bmRequestType)
			{
				if( usb_get_interface() )
					return;
			}
			break;

		case SETUP_SET_INTERFACE:
			if (bmRequestType == USB_SETUP_SET_STAND_INTERFACE)
			{
				if( usb_set_interface() )
					return;
			}
			break;

		default:
			break;
	}

	// Wv̂悤ȖxˎgpғǂݍݗvĂ
	if( !usb_user_read_request(bmRequestType, bmRequest) )
	{
		// ̪vꗗŖmv
		// (StallRq/clear RxSetupݒ)ۂA
		// ܂SETUPɌ㑱OUTv͉꓾܂B
		Usb_enable_stall_handshake();
		Usb_ack_receive_setup();
		endpoint_status[(EP_CONTROL & MSK_EP_DIR)] = 0x01;
	}
}

//! ̊֐ͱڽݒvǗ܂BAu͐Vڽgpėv
//! h߂ł傤B
//!
void usb_set_address (void)
{
	U8 addr = Usb_read_byte();
	Usb_configure_address(addr);

	Usb_ack_receive_setup();

	Usb_send_control_in();					// STATUSiKԂZLP𑗏o
	while(!Is_usb_in_ready()) {if(Is_usb_vbus_low())break;}	// VڽgpOSTATUSiKI҂
	Usb_enable_address();
}

//! ̊֐͌`ԐݒvǗ܂BIꂽ`Ԑݒ肪LȂÅ֐
//! ͌`Ԑݒԍɏ]Ĵ߲Ă`Ԑݒ肷usb_user_endpoint_init()֐
//! Ăт܂B
//!
Bool usb_set_configuration (void)
{
	U8 configuration_number;

	// V`Ԑݒ擾/
	configuration_number = Usb_read_byte();
	if (configuration_number > NB_CONFIGURATION)
		return FALSE;						//  `ԐݒԍȂAv~
	Usb_ack_receive_setup();
	usb_configuration_nb = configuration_number;

	Usb_send_control_in();					// STATUSiKZLPo
	usb_user_endpoint_init(usb_configuration_nb);	// ߲Č`Ԑݒ
	Usb_set_configuration_action();
	return TRUE;
}

//! ̊֐͋Lqq擾vǗ܂BuLqqA`ԐݒLqqAuC
//! qx܂B̑SĂ̋Lqqusb_user_get_descriptor֐ɂĎx
//! ܂B
//! 1̌`Ԑݒ肾x܂B
//!
Bool usb_get_descriptor (void)
{
	Bool zlp;
	U16  wLength;
	U8   descriptor_type;
	U8   string_type;
	U8   dummy;
	U8   nb_byte;
	U8   byte_to_send;
#if (USE_DEVICE_SN_UNIQUE==ENABLE)
	U16  sn_index=0;
	U8   initial_data_to_transfer;
#endif

	zlp             = FALSE;				/* 0߹ */
	string_type     = Usb_read_byte();		/* wValuẻ޲ēǂݍ */
	descriptor_type = Usb_read_byte();		/* wValuȅ޲ēǂݍ */

	switch (descriptor_type)
	{
		case DESCRIPTOR_DEVICE:
			data_to_transfer = Usb_get_dev_desc_length();	//!< sizeof (usb_user_device_descriptor);
			pbuffer          = Usb_get_dev_desc_pointer();
			break;

		case DESCRIPTOR_CONFIGURATION:
			data_to_transfer = Usb_get_conf_desc_length();	//!< sizeof (usb_user_configuration_descriptor);
			pbuffer          = Usb_get_conf_desc_pointer();
			break;

		default:
			if( !usb_user_get_descriptor(descriptor_type, string_type))
				return FALSE;				// m̋LqqȂAv~
			break;
	}

	dummy = Usb_read_byte();				//!< wIndeẍ͂ǂłǂ
	dummy = Usb_read_byte();
	LSB(wLength) = Usb_read_byte();			//!< wLengthǂݍ
	MSB(wLength) = Usb_read_byte();
	Usb_ack_receive_setup();				//!< SETUPM׸މ

	if (wLength > data_to_transfer)
	{
		if ((data_to_transfer % EP_CONTROL_LENGTH) == 0) { zlp = TRUE; }
		else { zlp = FALSE; }				//!< 0߹Ă̕KvȂ
	}
	else
	{
		data_to_transfer = (U8)wLength;		//!< vꂽްo
	}

	Usb_ack_nak_out();

	byte_to_send=0;
#if (USE_DEVICE_SN_UNIQUE==ENABLE)
	initial_data_to_transfer = data_to_transfer;
#endif
	while((data_to_transfer != 0) && (!Is_usb_nak_out_sent()))
	{
		while(!Is_usb_read_control_enabled())
		{
			if (Is_usb_nak_out_sent())
				break;						// ׸ނȂŁA͌ŉ܂B
		}

		nb_byte=0;
		while(data_to_transfer != 0)		//!< Kv܂ްo
		{
			if(nb_byte++==EP_CONTROL_LENGTH)	//!< ߲0eʌ
				break;

#if (USE_DEVICE_SN_UNIQUE==ENABLE)

			if(f_get_serial_string && (data_to_transfer < (initial_data_to_transfer-1)))	// [(3޲ĂƂȏ)𑗂ꍇA
			{																				// (ŏ2޲Ă͒ƋLqqłB)

				switch (byte_to_send)
				{
					case 0:
						Usb_write_byte(bin_to_ascii((Flash_read_sn(sn_index)>>4) & 0x0F));	// ASCIIɕϊꂽ[16i̍ŏ̕(MSB)𑗏o
						break;

					case 1:
						Usb_write_byte(0);	// NULLo(Usb_unicode)
						break;

					case 2:
						Usb_write_byte(bin_to_ascii(Flash_read_sn(sn_index) & 0x0F));	// ASCIIɕϊꂽ[16i2ڂ̕(LSB)𑗏o
						break;

					case 3:
						Usb_write_byte(0);	// NULLo(Usb_unicode)
						sn_index++;			// [ڽ ߲is()
						break;
				}
				byte_to_send = (byte_to_send+1)%4;
			}
			else
			{
				Usb_write_PGM_byte(pbuffer++);	// USBׯ ޲ď
			}
#else
			Usb_write_PGM_byte(pbuffer++);
#endif
			data_to_transfer --;			// M޲Đ
		}

		if (Is_usb_nak_out_sent())
			break;
		else
			Usb_send_control_in();
	}

#if (USE_DEVICE_SN_UNIQUE==ENABLE)
	f_get_serial_string=FALSE;				// [̍Ō𑗐M
#endif

	if((zlp == TRUE) && (!Is_usb_nak_out_sent()))
	{
		while(!Is_usb_read_control_enabled());
		Usb_send_control_in();
	}

	while (!(Is_usb_nak_out_sent()));
	Usb_ack_nak_out();
	Usb_ack_control_out();
	return TRUE;
}

//! ̊֐͌`Ԑݒ擾vǗ܂B݂̌`ԐݒԍԂ܂B
//!
void usb_get_configuration (void)
{
	Usb_ack_receive_setup();

	Usb_write_byte(usb_configuration_nb);
	Usb_ack_in_ready();

	while( !Is_usb_receive_out() );
	Usb_ack_receive_out();
}

//! ̊֐͏Ԏ擾vǗ܂BuA̪A܂ʹ߲Ă̏Ԃ
//! Ԃ܂B
//!
Bool usb_get_status (U8 bmRequestType)
{
	U8 wIndex;
	U8 dummy;

	dummy  = Usb_read_byte();				//!< Uǂݍ
	dummy  = Usb_read_byte();				//!< Uǂݍ
	wIndex = Usb_read_byte();

	switch(bmRequestType)
	{
		case USB_SETUP_GET_STAND_DEVICE:
			Usb_ack_receive_setup();
			Usb_write_byte(device_status);
			break;

		case USB_SETUP_GET_STAND_INTERFACE:
			Usb_ack_receive_setup();
			Usb_write_byte(0);				// (\) - 0
			break;

		case USB_SETUP_GET_STAND_ENDPOINT:
			Usb_ack_receive_setup();
			wIndex = wIndex & MSK_EP_DIR;
			Usb_write_byte( endpoint_status[wIndex] );
			break;

		default:
			return FALSE;
	}
	Usb_write_byte(0);

	Usb_send_control_in();
	while( !Is_usb_receive_out() );
	Usb_ack_receive_out();
	return TRUE;
}

//! ̊֐͋@\ݒvǗ܂BUSB͂̊֐ɂĎx܂B
//!
Bool usb_set_feature (U8 bmRequestType)
{
	U8 wValue;
	U8 wIndex;
	U8 dummy;

	switch (bmRequestType)
	{
		case USB_SETUP_SET_STAND_DEVICE:
			wValue = Usb_read_byte();
			switch (wValue)
			{
				case USB_REMOTE_WAKEUP:
					if ((wValue != FEATURE_DEVICE_REMOTE_WAKEUP)
					||  (USB_REMOTE_WAKEUP_FEATURE != ENABLED))
						return FALSE;		// v
					device_status |= USB_DEVICE_STATUS_REMOTEWAKEUP;
					remote_wakeup_feature = ENABLED;
					Usb_ack_receive_setup();
					Usb_send_control_in();
					break;

				default:
					return FALSE;			// m̗v
					break;
			}
			break;

		case USB_SETUP_SET_STAND_INTERFACE:
			return FALSE;					// m̗v
			break;

		case USB_SETUP_SET_STAND_ENDPOINT:
			wValue = Usb_read_byte();
			dummy  = Usb_read_byte();		//!< Uǂݍ
			if (wValue != FEATURE_ENDPOINT_HALT)
				return FALSE;				// m̗v
			wIndex = (Usb_read_byte() & MSK_EP_DIR);
			if (wIndex == EP_CONTROL)
			{
				Usb_enable_stall_handshake();
				Usb_ack_receive_setup();
			}
			Usb_select_endpoint(wIndex);
			if( !Is_usb_endpoint_enabled())
			{
				Usb_select_endpoint(EP_CONTROL);
				return FALSE;				// v
			}
			Usb_enable_stall_handshake();
			Usb_select_endpoint(EP_CONTROL);
			endpoint_status[wIndex] = 0x01;
			Usb_ack_receive_setup();
			Usb_send_control_in();
			break;

		default:
			return FALSE;					// m̗v
			break;
	}
	return TRUE;
}

//! ̊֐͋@\vǗ܂B
//!
Bool usb_clear_feature (U8 bmRequestType)
{
	U8 wValue;
	U8 wIndex;
	U8 dummy;

	switch (bmRequestType)
	{
		case USB_SETUP_SET_STAND_DEVICE:
			wValue = Usb_read_byte();
			if ((wValue != FEATURE_DEVICE_REMOTE_WAKEUP) || (USB_REMOTE_WAKEUP_FEATURE != ENABLED))
				return FALSE;				// v
			device_status &= ~USB_DEVICE_STATUS_REMOTEWAKEUP;
			remote_wakeup_feature = DISABLED;
			Usb_ack_receive_setup();
			Usb_send_control_in();
			break;

		case USB_SETUP_SET_STAND_INTERFACE:
			return FALSE;					// m̗v
			break;

		case USB_SETUP_SET_STAND_ENDPOINT:
			wValue = Usb_read_byte();
			dummy  = Usb_read_byte();
			if (wValue != FEATURE_ENDPOINT_HALT)
				return FALSE;				// m̗v
			wIndex = (Usb_read_byte() & MSK_EP_DIR);
			Usb_select_endpoint(wIndex);
			if( !Is_usb_endpoint_enabled())
			{
				Usb_select_endpoint(EP_CONTROL);
				return FALSE;				// v
			}
			if(wIndex != EP_CONTROL)
			{
				Usb_disable_stall_handshake();
				Usb_reset_endpoint(wIndex);
				Usb_reset_data_toggle();
			}
			Usb_select_endpoint(EP_CONTROL);
			endpoint_status[wIndex] = 0x00;
			Usb_ack_receive_setup();
			Usb_send_control_in();
			break;

		default:
			return FALSE;					// m̗v
			break;
	}
	return TRUE;
}

//! ̊֐Ͳ̪擾\ݒ(SETUP_GET_INTERFACE)vǗ܂B
//!
Bool usb_get_interface (void)
{
	U16 wInterface;
	U8  wValue_msb;
	U8  wValue_lsb;

	// wValueǂݍ
	wValue_lsb = Usb_read_byte();
	wValue_msb = Usb_read_byte();
	// wValue=֐ݒ
	// wIndex=̪
	LSB(wInterface)=Usb_read_byte();
	MSB(wInterface)=Usb_read_byte();
	if( (0!=wValue_msb) || (0!=wValue_msb) )
		return FALSE;
	Usb_ack_receive_setup();

	Usb_write_byte( usb_user_interface_get(wInterface) );
	Usb_send_control_in();

	while( !Is_usb_receive_out() );
	Usb_ack_receive_out();
	return TRUE;
}

//! ̊֐Ͳ̪ݒ\ݒ(SETUP_SET_INTERFACE)vǗ܂B
//!
Bool usb_set_interface (void)
{
	U16 wInterface;
	U8  wValue_msb;
	U8  wValue_lsb;

	// wValueǂݍ
	wValue_lsb = Usb_read_byte();
	wValue_msb = Usb_read_byte();
	// wValue=֐ݒ
	// wIndex=̪
	LSB(wInterface)=Usb_read_byte();
	MSB(wInterface)=Usb_read_byte();
	if( 0!=wValue_msb )
		return FALSE;
	Usb_ack_receive_setup();

	usb_user_interface_reset(wInterface, wValue_lsb);
	Usb_select_endpoint(EP_CONTROL);

	Usb_send_control_in();
	while(!Is_usb_in_ready());
	return TRUE;
}

//! ̊֐͉uNǗ܂B
//!
void usb_generate_remote_wakeup (void)
{
	if(Is_pll_ready()==FALSE)
	{
		Pll_start_auto();
		Wait_pll_ready();
	}
	Usb_unfreeze_clock();
	if (remote_wakeup_feature == ENABLED)
	{
		Usb_initiate_remote_wake_up();
		remote_wakeup_feature = DISABLED;
	}
}

#if ((USB_DEVICE_SN_USE==ENABLE) && (USE_DEVICE_SN_UNIQUE==ENABLE))
//! ̊֐4ޯĐlASCIIɕϊ̂Ɏgp܂B
//! 5'5'A10'A'
//! 
//! @param	ϊ2il
//!
//! @return	ϊꂽ
//!
U8 bin_to_ascii (U8 b)
{
	return ( (b <= 0x09) ? (b+'0') : (b+'A'-10) );
}
#endif
